diff -ruN clamav-0.86.2/clamscan/clamscan.c clamav-0.86.2.p1/clamscan/clamscan.c
--- clamav-0.86.2/clamscan/clamscan.c	Mon Jul 25 02:19:05 2005
+++ clamav-0.86.2.p1/clamscan/clamscan.c	Tue Aug  9 13:49:30 2005
@@ -34,7 +34,7 @@
 #include "defaults.h"
 #include "treewalk.h"
 #include "misc.h"
-
+#include "/usr/local/include/libunrar3/dll.hpp"
 #include "output.h"
 
 #ifdef C_LINUX
diff -ruN clamav-0.86.2/libclamav/scanners.c clamav-0.86.2.p1/libclamav/scanners.c
--- clamav-0.86.2/libclamav/scanners.c	Fri Jun 24 00:03:12 2005
+++ clamav-0.86.2.p1/libclamav/scanners.c	Tue Aug  9 14:20:03 2005
@@ -42,12 +42,13 @@
 
 #include <mspack.h>
 
+#ifndef UNRAR3
 #ifdef CL_THREAD_SAFE
 #  include <pthread.h>
 pthread_mutex_t cli_scanrar_mutex = PTHREAD_MUTEX_INITIALIZER;
 #endif
 int cli_scanrar_inuse = 0;
-
+#endif
 extern short cli_leavetemps_flag;
 
 extern int cli_mbox(const char *dir, int desc, unsigned int options); /* FIXME */
@@ -69,6 +70,8 @@
 #include "untar.h"
 #include "special.h"
 #include "binhex.h"
+#include "unrarlib.h"
+#include "/usr/local/include/libunrar3/dll.hpp"
 
 #ifdef HAVE_ZLIB_H
 #include <zlib.h>
@@ -107,10 +110,17 @@
 #define BLOCKMAX	    (options & CL_SCAN_BLOCKMAX)
 
 #define MAX_MAIL_RECURSION  15
-
+/*
+HANDLE PASCAL RAROpenArchive(struct RAROpenArchiveData *ArchiveData);
+HANDLE PASCAL RAROpenArchiveEx(struct RAROpenArchiveDataEx *ArchiveData);
+int    PASCAL RARCloseArchive(HANDLE hArcData);
+int    PASCAL RARProcessFile(HANDLE hArcData, struct RARHeaderData *HeaderData);
+*/
 static int cli_scanfile(const char *filename, const char **virname, unsigned long int *scanned, const struct cl_node *root, const struct cl_limits *limits, unsigned int options, unsigned int arec, unsigned int mrec);
 
 
+#define UNRAR3
+
 #ifdef CL_THREAD_SAFE
 static void cli_unlock_mutex(void *mtx)
 {
@@ -119,218 +129,6 @@
 }
 #endif
 
-static int cli_scanrar(int desc, const char **virname, long int *scanned, const struct cl_node *root, const struct cl_limits *limits, unsigned int options, unsigned int arec, unsigned int mrec)
-{
-	FILE *tmp = NULL;
-	int fd, ret = CL_CLEAN;
-	unsigned int files = 0, encrypted, afiles;
-	ArchiveList_struct *rarlist = NULL;
-	ArchiveList_struct *rarlist_head = NULL;
-	char *rar_data_ptr;
-	unsigned long rar_data_size;
-	struct cli_meta_node *mdata;
-
-
-    cli_dbgmsg("in scanrar()\n");
-
-#ifdef CL_THREAD_SAFE
-    pthread_cleanup_push(cli_unlock_mutex, &cli_scanrar_mutex);
-    pthread_mutex_lock(&cli_scanrar_mutex);
-    cli_scanrar_inuse = 1;
-#endif
-
-    if(!(afiles = urarlib_list(desc, (ArchiveList_struct *) &rarlist))) {
-#ifdef CL_THREAD_SAFE
-	pthread_mutex_unlock(&cli_scanrar_mutex);
-	cli_scanrar_inuse = 0;
-#endif
-	return CL_ERAR;
-    }
-
-    cli_dbgmsg("RAR: Number of archived files: %d\n", afiles);
-
-    rarlist_head = rarlist;
-
-    while(rarlist) {
-
-	files++;
-	encrypted = rarlist->item.Flags & 0x04;
-
-	cli_dbgmsg("RAR: %s, crc32: 0x%x, encrypted: %d, compressed: %u, normal: %u, method: %d, ratio: %d (max: %d)\n", rarlist->item.Name, rarlist->item.FileCRC, encrypted, rarlist->item.PackSize, rarlist->item.UnpSize, rarlist->item.Method, rarlist->item.PackSize ? ((unsigned int) rarlist->item.UnpSize / (unsigned int) rarlist->item.PackSize) : 0, limits ? limits->maxratio : 0);
-
-	/* Scan metadata */
-	mdata = root->rar_mlist;
-	if(mdata) do {
-	    if(mdata->encrypted != encrypted)
-		continue;
-
-	    if(mdata->crc32 && (unsigned int) mdata->crc32 != rarlist->item.FileCRC)
-		continue;
-
-	    if(mdata->csize > 0 && (unsigned int) mdata->csize != rarlist->item.PackSize)
-		continue;
-
-	    if(mdata->size >= 0 && (unsigned int) mdata->size != rarlist->item.UnpSize)
-		continue;
-
-	    if(mdata->method >= 0 && mdata->method != rarlist->item.Method)
-		continue;
-
-	    if(mdata->fileno && mdata->fileno != files)
-		continue;
-
-	    if(mdata->maxdepth && arec > mdata->maxdepth)
-		continue;
-
-	    /* TODO add support for regex */
-	    /*if(mdata->filename && !strstr(zdirent.d_name, mdata->filename))*/
-	    if(mdata->filename && strcmp(rarlist->item.Name, mdata->filename))
-		continue;
-
-	    break; /* matched */
-
-	} while((mdata = mdata->next));
-
-	if(mdata) {
-	    *virname = mdata->virname;
-	    ret = CL_VIRUS;
-	    break;
-	}
-
-	if(DETECT_ENCRYPTED && (rarlist->item.Flags & 0x04)) {
-	    cli_dbgmsg("RAR: Encrypted files found in archive.\n");
-	    lseek(desc, 0, SEEK_SET);
-	    ret = cli_scandesc(desc, virname, scanned, root, 0, 0);
-	    if(ret < 0) {
-		break;
-	    } else if(ret != CL_VIRUS) {
-		*virname = "Encrypted.RAR";
-		ret = CL_VIRUS;
-	    }
-	    break;
-	}
-
-	if((rarlist->item.Flags & 0x03) != 0) {
-	    cli_dbgmsg("RAR: Skipping %s (splitted)\n", rarlist->item.Name);
-	    rarlist = rarlist->next;
-	    continue;
-	}
-
-	if(limits) {
-
-	    if(limits->maxratio && rarlist->item.UnpSize && rarlist->item.PackSize) {
-		if((unsigned int) rarlist->item.UnpSize / (unsigned int) rarlist->item.PackSize >= limits->maxratio) {
-		    cli_dbgmsg("RAR: Max ratio reached (normal: %d, compressed: %d, max: %ld)\n", (int) rarlist->item.UnpSize, (int) rarlist->item.PackSize, limits->maxratio);
-		    *virname = "Oversized.RAR";
-		    ret = CL_VIRUS;
-		    break;
-		}
-	    }
-
-	    if(limits->maxfilesize && (rarlist->item.UnpSize > (unsigned int) limits->maxfilesize)) {
-		cli_dbgmsg("RAR: %s: Size exceeded (%u, max: %lu)\n", rarlist->item.Name, (unsigned int) rarlist->item.UnpSize, limits->maxfilesize);
-		rarlist = rarlist->next;
-		if(BLOCKMAX) {
-		    *virname = "RAR.ExceededFileSize";
-		    ret = CL_VIRUS;
-		    break;
-		}
-		continue;
-	    }
-
-	    if(limits->maxfiles && (files > limits->maxfiles)) {
-		cli_dbgmsg("RAR: Files limit reached (max: %d)\n", limits->maxfiles);
-		if(BLOCKMAX) {
-		    *virname = "RAR.ExceededFilesLimit";
-		    ret = CL_VIRUS;
-		    break;
-		}
-		break;
-	    }
-	}
-
-        if(rarlist->item.FileAttr & RAR_FENTRY_ATTR_DIRECTORY) {
-            rarlist = rarlist->next;
-            continue;
-        }
-
-	if((tmp = tmpfile()) == NULL) {
-	    cli_dbgmsg("RAR: Can't generate temporary file.\n");
-#ifdef CL_THREAD_SAFE
-	    pthread_mutex_unlock(&cli_scanrar_mutex);
-	    cli_scanrar_inuse = 0;
-#endif
-	    return CL_ETMPFILE;
-	}
-	fd = fileno(tmp);
-
-	if( urarlib_get(&rar_data_ptr, &rar_data_size, rarlist->item.Name, desc, "clam")) {
-	    cli_dbgmsg("RAR: Extracted: %s, size: %lu\n", rarlist->item.Name, rar_data_size);
-	    if(fwrite(rar_data_ptr, 1, rar_data_size, tmp) != rar_data_size) {
-		cli_dbgmsg("RAR: Can't write to file.\n");
-		fclose(tmp);
-		tmp = NULL;
-		ret = CL_ERAR;
-		if(rar_data_ptr) {
-		    free(rar_data_ptr);
-		    rar_data_ptr = NULL;
-		}
-		break;
-	    }
-
-	    if(rar_data_ptr) {
-		free(rar_data_ptr);
-		rar_data_ptr = NULL;
-	    }
-	    if(fflush(tmp) != 0) {
-		cli_dbgmsg("RAR: fflush() failed: %s\n", strerror(errno));
-		fclose(tmp);
-		urarlib_freelist(rarlist_head);
-#ifdef CL_THREAD_SAFE
-		pthread_mutex_unlock(&cli_scanrar_mutex);
-		cli_scanrar_inuse = 0;
-#endif
-		return CL_EFSYNC;
-	    }
-
-	    lseek(fd, 0, SEEK_SET);
-	    if((ret = cli_magic_scandesc(fd, virname, scanned, root, limits, options, arec, mrec)) == CL_VIRUS ) {
-		cli_dbgmsg("RAR: Infected with %s\n", *virname);
-
-		fclose(tmp);
-		urarlib_freelist(rarlist);
-#ifdef CL_THREAD_SAFE
-		pthread_mutex_unlock(&cli_scanrar_mutex);
-		cli_scanrar_inuse = 0;
-#endif
-  		return ret;
-	    }
-
-	} else {
-	    cli_dbgmsg("RAR: Can't decompress file %s\n", rarlist->item.Name);
-	    fclose(tmp);
-	    tmp = NULL;
-	    ret = CL_ERAR; /* WinRAR 3.0 ? */
-	    break;
-	}
-
-	fclose(tmp);
-	tmp = NULL;
-	rarlist = rarlist->next;
-    }
-
-    urarlib_freelist(rarlist_head);
-#ifdef CL_THREAD_SAFE
-    pthread_mutex_unlock(&cli_scanrar_mutex);
-    cli_scanrar_inuse = 0;
-    pthread_cleanup_pop(0);
-#endif
-    
-    cli_dbgmsg("RAR: Exit code: %d\n", ret);
-
-    return ret;
-}
-
 #ifdef HAVE_ZLIB_H
 static int cli_scanzip(int desc, const char **virname, long int *scanned, const struct cl_node *root, const struct cl_limits *limits, unsigned int options, unsigned int arec, unsigned int mrec)
 {
@@ -562,6 +360,43 @@
     return ret;
 }
 
+#ifdef UNRAR3
+static int cli_scanrar3(int desc, const char **virname, long int *scanned, const struct cl_node *root, const struct cl_limits *limits, unsigned int options, int *arec, int *mrec)
+{
+const char *tmpdir;
+char *dir;
+int ret = CL_CLEAN;
+
+
+    cli_dbgmsg("in cli_scanrar3()\n");
+
+    if((tmpdir = getenv("TMPDIR")) == NULL)
+#ifdef P_tmpdir
+tmpdir = P_tmpdir;
+#else
+tmpdir = "/tmp";
+#endif
+
+    /* generate temporary directory */
+    dir = cli_gentemp(tmpdir);
+    if(mkdir(dir, 0700)) {
+	cli_errmsg("Rar3: Can't create temporary directory %s\n", dir);
+	return CL_ETMPDIR;
+    }
+
+    if((ret = cli_unrar3(dir, desc)))
+	cli_dbgmsg("Rar3: %s\n", cl_strerror(ret));
+    else
+	ret = cli_scandir(dir, virname, scanned, root, limits, options, arec, mrec);
+
+    if(!cli_leavetemps_flag)
+	cli_rmdirs(dir);
+
+    free(dir);
+    return ret;
+}
+#endif
+
 static int cli_scangzip(int desc, const char **virname, long int *scanned, const struct cl_node *root, const struct cl_limits *limits, unsigned int options, unsigned int arec, unsigned int mrec)
 {
 	int fd, bytes, ret = CL_CLEAN;
@@ -1403,8 +1238,13 @@
 
     switch(type) {
 	case CL_TYPE_RAR:
+#ifdef UNRAR3
+	    if(!DISABLE_RAR && SCAN_ARCHIVE)
+		ret = cli_scanrar3(desc, virname, scanned, root, limits, options, arec, mrec);
+#else
 	    if(!DISABLE_RAR && SCAN_ARCHIVE && !cli_scanrar_inuse)
 		ret = cli_scanrar(desc, virname, scanned, root, limits, options, arec, mrec);
+#endif
 	    break;
 
 	case CL_TYPE_ZIP:
@@ -1541,8 +1381,17 @@
 	 * in raw mode. Now we will try to unpack them
 	 */
 	case CL_TYPE_MSEXE:
+#ifdef UNRAR3
+	    if(!DISABLE_RAR && SCAN_ARCHIVE)
+		ret = cli_scanrar3(desc, virname, scanned, root, limits, options, arec, mrec);
+	    if(SCAN_PE && ret != CL_VIRUS)
+#else
 	    if(SCAN_PE)
+#endif
+	    {
+		lseek(desc, 0, SEEK_SET);
 		ret = cli_scanpe(desc, virname, scanned, root, limits, options, arec, mrec);
+	    }
 	    break;
 
 	default:
